function aadotdemo(action)

if nargin == 0
  action = 'Initialize';
end

switch action
 case 'Initialize'
  % create the main figure
  h.npix = 64; % number of pixels along one dimension
  h.sigma = 0.7; % standard deviation of the gaussian filter
  h.gamma = 2; % gamma of the display
  
  h.P0 = [1, h.npix/2]; % starting position of the point
  h.P1 = [h.npix, h.npix/2 + 5]; % ending position of the point
  
  h.figh = figure('name', 'Dot Demo', ...
		 'numbertitle','off','Position',[80 0 950 700],...
		 'units', 'pixels', 'doublebuffer', 'on');
  h.im = image(zeros(h.npix, h.npix));
  colormap(gray(256));
  axis image;
  
  h.PSlider = uicontrol(gcf, ...
			   'Style', 'slider', ...
			   'Position', [60 400 20 250], ...
			   'Min', 0, 'Max', 1, 'Value', 0, ...
			   'SliderStep', [0.1/h.npix 1/h.npix], ...
			   'CallBack', 'aadotdemo Slider');
  
  set(gcf, 'UserData', h);
  
 case 'Slider'
  h = get(gcbf,'UserData'); % retreive the handle we squirreled away
  val = get(gco, 'Value'); % get the value of the slider
  pos = h.P1 * val + h.P0 * (1 - val); % convert it to a screen position
  
  % compute the distance of every pixel from the desired point
  [x,y] = meshgrid(1:h.npix);
  r = sqrt((x - pos(1)).^2 + (y - pos(2)).^2);
  
  i = gauss(r, h.sigma); % use a gaussian filter kernel
  g = i .^ (1./h.gamma); % gamma correct
  set(h.im, 'CData', 255*g); % update the image
  set(gcf, 'UserData', h);
  
end
  
  
