function dotdemo(action)

if nargin == 0
  action = 'Initialize';
end

switch action
 case 'Initialize'
  % create the main figure
  h.npix = 64;
  h.gamma = 2;
  h.P0 = [1, h.npix/2];
  h.P1 = [h.npix, h.npix/2 + 5];
  
  h.figh = figure('name', 'Dot Demo', ...
		 'numbertitle','off','Position',[80 0 950 700],...
		 'units', 'pixels', 'doublebuffer', 'on');
  h.im = image(zeros(h.npix, h.npix));
  colormap(gray(256));
  axis image;
  
  h.PSlider = uicontrol(gcf, ...
			   'Style', 'slider', ...
			   'Position', [60 400 20 250], ...
			   'Min', 0, 'Max', 1, 'Value', 0, ...
			   'SliderStep', [0.1/h.npix 1/h.npix], ...
			   'CallBack', 'dotdemo Slider');
  
  set(gcf, 'UserData', h);
  
 case 'Slider'
  h = get(gcbf,'UserData');
  val = get(gco, 'Value');
  pos = h.P1 * val + h.P0 * (1 - val);
  i = zeros(h.npix, h.npix);
  i(fix(pos(2)), fix(pos(1))) = 1;
  g = i .^ (1./h.gamma);
  set(h.im, 'CData', 255*g);
  
  set(gcf, 'UserData', h);
  
end
  
  
